Bug 1705544 - kdevelop-python FTBFS with Python 3.8
Summary: kdevelop-python FTBFS with Python 3.8
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: kdevelop-python
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
Assignee: Minh Ngo
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: F32FTBFS F32FailsToInstall PYTHON38
TreeView+ depends on / blocked
 
Reported: 2019-05-02 13:16 UTC by Miro Hrončok
Modified: 2019-11-17 23:39 UTC (History)
5 users (show)

Fixed In Version: kdevelop-python-5.4.3-1.fc32
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-11-17 23:39:21 UTC
Type: Bug


Attachments (Terms of Use)
Full log from Copr (290.83 KB, text/plain)
2019-05-02 13:16 UTC, Miro Hrončok
no flags Details

Description Miro Hrončok 2019-05-02 13:16:42 UTC
Created attachment 1561612 [details]
Full log from Copr

kdevelop-python 5.3.2-2.py3.fc31 fails to build with Python 3.8 (the failure might not be Python 3.8 related):

[ 16%] Building CXX object parser/CMakeFiles/kdevpythonparser.dir/cythonsyntaxremover.cpp.o
cd /builddir/build/BUILD/kdev-python-5.3.2/x86_64-redhat-linux-gnu/parser && /usr/bin/c++  -DKCOREADDONS_LIB -DQT_CONCURRENT_LIB -DQT_CORE_LIB -DQT_DBUS_LIB -DQT_GUI_LIB -DQT_NETWORK_LIB -DQT_NO_DEBUG -DQT_WIDGETS_LIB -DQT_XML_LIB -DTRANSLATION_DOMAIN=\"kdevpython\" -D_GNU_SOURCE -D_LARGEFILE64_SOURCE -Dkdevpythonparser_EXPORTS -I/builddir/build/BUILD/kdev-python-5.3.2/x86_64-redhat-linux-gnu/parser -I/builddir/build/BUILD/kdev-python-5.3.2/parser -I/builddir/build/BUILD/kdev-python-5.3.2/x86_64-redhat-linux-gnu/parser/kdevpythonparser_autogen/include -I/builddir/build/BUILD/kdev-python-5.3.2/x86_64-redhat-linux-gnu -I/builddir/build/BUILD/kdev-python-5.3.2 -I/builddir/build/BUILD/kdev-python-5.3.2/duchain -I/usr/include/python3.8m -isystem /usr/include/kdevplatform -isystem /usr/include/KF5/KWidgetsAddons -isystem /usr/include/KF5 -isystem /usr/include/qt5 -isystem /usr/include/qt5/QtWidgets -isystem /usr/include/qt5/QtGui -isystem /usr/include/qt5/QtCore -isystem /usr/lib64/qt5/mkspecs/linux-g++ -isystem /usr/include/KF5/KI18n -isystem /usr/include/KF5/KTextEditor -isystem /usr/include/KF5/KParts -isystem /usr/include/KF5/KIOWidgets -isystem /usr/include/KF5/KIOCore -isystem /usr/include/KF5/KCoreAddons -isystem /usr/include/KF5/KService -isystem /usr/include/KF5/KConfigCore -isystem /usr/include/qt5/QtNetwork -isystem /usr/include/qt5/QtConcurrent -isystem /usr/include/qt5/QtDBus -isystem /usr/include/KF5/KJobWidgets -isystem /usr/include/KF5/KCompletion -isystem /usr/include/KF5/KXmlGui -isystem /usr/include/qt5/QtXml -isystem /usr/include/KF5/KConfigWidgets -isystem /usr/include/KF5/KCodecs -isystem /usr/include/KF5/KConfigGui -isystem /usr/include/KF5/KAuth -isystem /usr/include/KF5/KTextWidgets -isystem /usr/include/KF5/SonnetUi -isystem /usr/include/KF5/ThreadWeaver  -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fexceptions -fstack-protector-strong -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1 -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -std=c++0x -fno-operator-names -fno-exceptions -Wall -Wextra -Wcast-align -Wchar-subscripts -Wformat-security -Wno-long-long -Wpointer-arith -Wundef -Wnon-virtual-dtor -Woverloaded-virtual -Werror=return-type -Wvla -Wdate-time -Wsuggest-override -Wlogical-op -DNDEBUG -fPIC -fvisibility=hidden -fvisibility-inlines-hidden   -fPIC -std=gnu++11 -o CMakeFiles/kdevpythonparser.dir/cythonsyntaxremover.cpp.o -c /builddir/build/BUILD/kdev-python-5.3.2/parser/cythonsyntaxremover.cpp
In file included from /usr/include/python3.8m/pytime.h:6,
                 from /usr/include/python3.8m/Python.h:85,
                 from /builddir/build/BUILD/kdev-python-5.3.2/parser/python_header.h:35,
                 from /builddir/build/BUILD/kdev-python-5.3.2/parser/astbuilder.cpp:31:
/usr/include/python3.8m/object.h: In function 'void _Py_ForgetReference(PyObject*)':
/usr/include/python3.8m/object.h:441:50: warning: unused parameter 'op' [-Wunused-parameter]
  441 | static inline void _Py_ForgetReference(PyObject *op)
      |                                        ~~~~~~~~~~^~
/usr/include/python3.8m/object.h: In function 'void _Py_DECREF(const char*, int, PyObject*)':
/usr/include/python3.8m/object.h:458:43: warning: unused parameter 'filename' [-Wunused-parameter]
  458 | static inline void _Py_DECREF(const char *filename, int lineno,
      |                               ~~~~~~~~~~~~^~~~~~~~
/usr/include/python3.8m/object.h:458:57: warning: unused parameter 'lineno' [-Wunused-parameter]
  458 | static inline void _Py_DECREF(const char *filename, int lineno,
      |                                                     ~~~~^~~~~~
In file included from /builddir/build/BUILD/kdev-python-5.3.2/parser/astbuilder.cpp:44:
/builddir/build/BUILD/kdev-python-5.3.2/parser/generated.h: In member function 'Python::Ast* Python::PythonAstTransformer::visitNode(_expr*)':
/builddir/build/BUILD/kdev-python-5.3.2/parser/generated.h:283:14: error: 'Num_kind' was not declared in this scope; did you mean 'Name_kind'?
  283 |         case Num_kind: {
      |              ^~~~~~~~
      |              Name_kind
In file included from /usr/include/python3.8m/object.h:715,
                 from /usr/include/python3.8m/pytime.h:6,
                 from /usr/include/python3.8m/Python.h:85,
                 from /builddir/build/BUILD/kdev-python-5.3.2/parser/python_header.h:35,
                 from /builddir/build/BUILD/kdev-python-5.3.2/parser/astbuilder.cpp:31:
/builddir/build/BUILD/kdev-python-5.3.2/parser/generated.h:285:34: error: 'union _expr::<unnamed>' has no member named 'Num'
  285 |  v->isInt = PyLong_Check(node->v.Num.n); v->value = PyLong_AsLong(node->v.Num.n);
      |                                  ^~~
/usr/include/python3.8m/cpython/object.h:333:36: note: in definition of macro 'PyType_HasFeature'
  333 | #define PyType_HasFeature(t,f)  (((t)->tp_flags & (f)) != 0)
      |                                    ^
/usr/include/python3.8m/longobject.h:15:9: note: in expansion of macro 'PyType_FastSubclass'
   15 |         PyType_FastSubclass(Py_TYPE(op), Py_TPFLAGS_LONG_SUBCLASS)
      |         ^~~~~~~~~~~~~~~~~~~
/usr/include/python3.8m/object.h:127:34: note: in expansion of macro '_PyObject_CAST'
  127 | #define Py_TYPE(ob)             (_PyObject_CAST(ob)->ob_type)
      |                                  ^~~~~~~~~~~~~~
/usr/include/python3.8m/longobject.h:15:29: note: in expansion of macro 'Py_TYPE'
   15 |         PyType_FastSubclass(Py_TYPE(op), Py_TPFLAGS_LONG_SUBCLASS)
      |                             ^~~~~~~
/builddir/build/BUILD/kdev-python-5.3.2/parser/generated.h:285:13: note: in expansion of macro 'PyLong_Check'
  285 |  v->isInt = PyLong_Check(node->v.Num.n); v->value = PyLong_AsLong(node->v.Num.n);
      |             ^~~~~~~~~~~~
In file included from /builddir/build/BUILD/kdev-python-5.3.2/parser/astbuilder.cpp:44:
/builddir/build/BUILD/kdev-python-5.3.2/parser/generated.h:285:75: error: 'union _expr::<unnamed>' has no member named 'Num'
  285 |  v->isInt = PyLong_Check(node->v.Num.n); v->value = PyLong_AsLong(node->v.Num.n);
      |                                                                           ^~~
/builddir/build/BUILD/kdev-python-5.3.2/parser/generated.h:289:14: error: 'Str_kind' was not declared in this scope; did you mean 'Set_kind'?
  289 |         case Str_kind: {
      |              ^~~~~~~~
      |              Set_kind
/builddir/build/BUILD/kdev-python-5.3.2/parser/generated.h:291:61: error: 'union _expr::<unnamed>' has no member named 'Str'
  291 |                 v->value = PyUnicodeObjectToQString(node->v.Str.s);
      |                                                             ^~~
In file included from /builddir/build/BUILD/kdev-python-5.3.2/parser/astbuilder.cpp:44:
/builddir/build/BUILD/kdev-python-5.3.2/parser/generated.h:313:14: error: 'Bytes_kind' was not declared in this scope
  313 |         case Bytes_kind: {
      |              ^~~~~~~~~~
/builddir/build/BUILD/kdev-python-5.3.2/parser/generated.h:315:61: error: 'union _expr::<unnamed>' has no member named 'Bytes'
  315 |                 v->value = PyUnicodeObjectToQString(node->v.Bytes.s);
      |                                                             ^~~~~
/builddir/build/BUILD/kdev-python-5.3.2/parser/generated.h:377:14: error: 'Ellipsis_kind' was not declared in this scope; did you mean 'EllipsisAst'?
  377 |         case Ellipsis_kind: {
      |              ^~~~~~~~~~~~~
      |              EllipsisAst
/builddir/build/BUILD/kdev-python-5.3.2/parser/generated.h:382:14: error: 'NameConstant_kind' was not declared in this scope; did you mean 'Constant_kind'?
  382 |         case NameConstant_kind: {
      |              ^~~~~~~~~~~~~~~~~
      |              Constant_kind
/builddir/build/BUILD/kdev-python-5.3.2/parser/generated.h:384:36: error: 'union _expr::<unnamed>' has no member named 'NameConstant'; did you mean 'Constant'?
  384 |                 v->value = node->v.NameConstant.value == Py_None ? NameConstantAst::None : node->v.NameConstant.value == Py_False ? NameConstantAst::False : NameConstantAst::True;
      |                                    ^~~~~~~~~~~~
      |                                    Constant
/builddir/build/BUILD/kdev-python-5.3.2/parser/generated.h:384:100: error: 'union _expr::<unnamed>' has no member named 'NameConstant'; did you mean 'Constant'?
  384 |                 v->value = node->v.NameConstant.value == Py_None ? NameConstantAst::None : node->v.NameConstant.value == Py_False ? NameConstantAst::False : NameConstantAst::True;
      |                                                                                                    ^~~~~~~~~~~~
      |                                                                                                    Constant
/builddir/build/BUILD/kdev-python-5.3.2/parser/astbuilder.cpp: In member function 'Python::CodeAst::Ptr Python::AstBuilder::parse(const QUrl&, QString&)':
/builddir/build/BUILD/kdev-python-5.3.2/parser/astbuilder.cpp:104:70: warning: missing initializer for member 'PyCompilerFlags::cf_feature_version' [-Wmissing-field-initializers]
  104 |     PyCompilerFlags flags = {PyCF_SOURCE_IS_UTF8 | PyCF_IGNORE_COOKIE};
      |                                                                      ^
make[2]: *** [parser/CMakeFiles/kdevpythonparser.dir/build.make:144: parser/CMakeFiles/kdevpythonparser.dir/astbuilder.cpp.o] Error 1
make[2]: *** Waiting for unfinished jobs....
In file included from /builddir/build/BUILD/kdev-python-5.3.2/parser/astvisitor.h:27,
                 from /builddir/build/BUILD/kdev-python-5.3.2/parser/astdefaultvisitor.h:26,
                 from /builddir/build/BUILD/kdev-python-5.3.2/parser/cythonsyntaxremover.cpp:23:
/builddir/build/BUILD/kdev-python-5.3.2/parser/ast.h: In member function 'Python::Identifier Python::Identifier::operator=(const Python::Identifier&)':
/builddir/build/BUILD/kdev-python-5.3.2/parser/ast.h:254:17: warning: implicitly-declared 'Python::Identifier::Identifier(const Python::Identifier&)' is deprecated [-Wdeprecated-copy]
  254 |         return *this;
      |                 ^~~~
/builddir/build/BUILD/kdev-python-5.3.2/parser/ast.h:246:16: note: because 'Python::Identifier' has user-provided 'Python::Identifier Python::Identifier::operator=(const Python::Identifier&)'
  246 |     Identifier operator=(const Identifier& other) {
      |                ^~~~~~~~
make[2]: Leaving directory '/builddir/build/BUILD/kdev-python-5.3.2/x86_64-redhat-linux-gnu'
make[1]: Leaving directory '/builddir/build/BUILD/kdev-python-5.3.2/x86_64-redhat-linux-gnu'
make[1]: *** [CMakeFiles/Makefile2:504: parser/CMakeFiles/kdevpythonparser.dir/all] Error 2
make: Leaving directory '/builddir/build/BUILD/kdev-python-5.3.2/x86_64-redhat-linux-gnu'
make: *** [Makefile:133: all] Error 2

Full log attached.

Comment 1 Miro Hrončok 2019-07-10 10:15:33 UTC
Please respond.

Comment 2 Jan Grulich 2019-07-12 10:09:27 UTC
It is most likely Python related, I just did a scratch build in rawhide and it builds just fine. I guess the code is not Python 3.8 ready yet and I did check upstream and sadly there is no activity, no one seem to add support for it yet.

Comment 3 Miro Hrončok 2019-07-12 11:04:37 UTC
It is indeed Python related.

Num_kind, Str_kind, Bytes_kind, NameConstant_kind, Ellipsis_kind were replaced with Constant_kind. See https://github.com/python/cpython/pull/9445 and https://bugs.python.org/issue32892

Useful links for testing:

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.8: https://copr.fedorainfracloud.org/coprs/g/python/python3.8/

The Fedora change for reference: https://fedoraproject.org/wiki/Changes/Python3.8

Comment 4 Ben Cotton 2019-08-13 17:03:58 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to '31'.

Comment 5 Ben Cotton 2019-08-13 19:02:53 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to 31.

Comment 6 Miro Hrončok 2019-08-14 22:24:47 UTC
The coordinated rebuild of Python 3.8 has started in the `f32-python` side tag.

If you figure out how to rebuild this package, please don't rebuild it in regular rawhide, but use the side tag instead:

    on branch master:
    $ fedpkg build --target=f32-python

To wait for a build to show up in the side tag, do:

    $ koji wait-repo f32-python --build=<nvr>

Where <nvr> is name-version-release of the source package, e.g. python-foo-1.1-2.fc32.

An updated mock config is posted at:
http://copr.fedorainfracloud.org/coprs/g/python/python3.8/

Note that it will take a while before the essential packages are rebuilt, so don't expect all your dependencies to be available right away.

Thanks. Let us know if you need up to date info, or if you have any questions.



PS this message is mass posted to all the bugs that block the PYTHON38 bug. If this is also a Fedora 31 FTBFS bug and you manage to fix it, you can do a f31 build as usual:

    on branch f31:
    $ fedpkg build

Comment 7 Miro Hrončok 2019-08-21 16:35:33 UTC
The f32-python side tag has been merged. In order to rebuild the package, do it in regular rawhide, but please wait until python3-3.8 is tagged:

  $ koji wait-repo f32-build --build python3-3.8.0~b3-3.fc32


If your built already started in f32-python, after it is finished, please tag it to rawhide with:

  $ koji tag-build f32-pending <nvr>

For example:

  $ koji tag-build f32-pending libreoffice-6.3.0.4-3.fc32

Thanks!

(This comment is mass posted to all bugzillas blocking the PYTHON38 tracking bug.)

Comment 8 Miro Hrončok 2019-08-21 17:29:31 UTC
(Python 3.8 has landed in the rawhide buildroot.)

Comment 9 Miro Hrončok 2019-09-16 07:51:33 UTC
This issue is blocking the Python 3.8 rebuilds. If this package won't build with 3.8, it won't be installable, along with all its dependent packages, in Fedora 32.
Furthermore, as it fails to install, its dependent packages will fail to install and/or build as well.

If upstream isn't Python 3.8 ready, could you please open an issue with them?

Comment 10 Jan Grulich 2019-09-16 08:54:42 UTC
I opened upstream bug: https://bugs.kde.org/show_bug.cgi?id=411956

Comment 11 Miro Hrončok 2019-11-17 23:39:21 UTC
Thanks for the fix.


Note You need to log in before you can comment on or make changes to this bug.